%define name		xalan-j2
%define xsltcname	xsltc
%define version		2.4.1
%define cvs_version	2_4_1
%define release		2jpp
%define javadir		%{_datadir}/java
%define javadocdir	%{_datadir}/javadoc
%define section		free

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Java XSLT processor
License:	Apache Software License
Source0:	http://xml.apache.org/dist/xalan-j/xalan-j_%{cvs_version}-src.tar.gz
Patch0:		%{name}-2.4.patch
URL:		http://xml.apache.org/xalan-j/
Group:		Text Processing/Markup/XML
Vendor:		JPackage Project
Distribution:	JPackage
Provides:	jaxp_transform_impl
Requires:	jaxp_parser_impl
Requires:	/usr/sbin/update-alternatives
BuildRequires:	ant
#BuildRequires:	xerces-j1
#BuildRequires:	stylebook1.0b3
BuildRequires:	xml-commons-apis
BuildRequires:	bcel
BuildRequires:	oldbsf
BuildRequires:	servletapi3
BuildRequires:	jlex >= 1.2.5-5jpp
BuildRequires:	java_cup
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot


%description
Xalan is an XSLT processor for transforming XML documents into HTML,
text, or other XML document types. It implements the W3C Recommendations
for XSL Transformations (XSLT) and the XML Path Language (XPath). It can
be used from the command line, in an applet or a servlet, or as a module
in other program.

%package %{xsltcname}
Summary:	XSLT compiler
Group:		Text Processing/Markup/XML
Requires:	java_cup, bcel, jlex >= 1.2.5-5jpp, regexp, jaxp_parser_impl
Requires:	/usr/sbin/update-alternatives
Provides:	jaxp_transform_impl

%description %{xsltcname}
The XSLT Compiler is a Java-based tool for compiling XSLT stylesheets into 
lightweight and portable Java byte codes called translets.

%package 	manual
Summary:	Manual for %{name}
Group:		Text Processing/Markup/XML
#BuildRequires:	stylebook1.0b3

%description manual
Documentation for %{name}.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%package demo
Summary:	Demo for %{name}
Group:		Text Processing/Markup/XML
Requires:	servlet
BuildRequires:	servlet
Requires:	%{name} = %{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -n xalan-j_%{cvs_version}
%patch0 -p0
# remove all binary libs
find . -name "*.jar" ! -name "xalan2jdoc.jar" ! -name "stylebook-1.0-b3_xalan-2.jar" -exec rm -f {} \;

%build
export CLASSPATH=%{javadir}/servlet.jar
ant -Dxmlapis.jar=%{javadir}/xml-commons-apis.jar -Dparser.jar=%{javadir}/jaxp_parser_impl.jar -Dbcel.jar=%{javadir}/bcel.jar -Dbsf.jar=%{javadir}/oldbsf.jar -Djlex.jar=%{javadir}/jlex.jar -Djava_cup.jar=%{javadir}/java_cup.jar -Druntime.jar=%{javadir}/java_cup-runtime.jar -Dbuild.compiler=modern jar xsltc.unbundledjar docs xsltc.docs javadocs samples servlet 

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{javadir}
install -m 644 build/xalan.jar $RPM_BUILD_ROOT%{javadir}/%{name}-%{version}.jar
install -m 644 build/xsltc.jar $RPM_BUILD_ROOT%{javadir}/%{xsltcname}-%{version}.jar
(cd $RPM_BUILD_ROOT%{javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr build/docs/apidocs/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
rm -rf build/docs/apidocs
# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 build/xalansamples.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-samples.jar
install -m 644 build/xalanservlet.jar $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-servlet.jar
cp -pr samples $RPM_BUILD_ROOT%{_datadir}/%{name}
# fix link between manual and javadoc
(cd build/docs; ln -sf %{javadocdir}/%{name}-%{version} apidocs)

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{javadir}/jaxp_transform_impl.jar \
  jaxp_transform_impl %{javadir}/%{name}.jar 30

%post %{xsltcname}
update-alternatives --install %{javadir}/jaxp_transform_impl.jar \
  jaxp_transform_impl %{javadir}/%{xsltcname}.jar 10

%postun
if [ "$1" = "0" ]; then # on erase
  update-alternatives --remove jaxp_transform_impl %{javadir}/%{name}.jar
fi

%postun %{xsltcname}
if [ "$1" = "0" ]; then # on erase
  update-alternatives --remove jaxp_transform_impl %{javadir}/%{xsltcname}.jar
fi

%files
%defattr(-,root,root,-)
%doc KEYS License
%{javadir}/%{name}-%{version}.jar
%{javadir}/%{name}.jar

%files %{xsltcname}
%defattr(-,root,root,-)
%{javadir}/xsltc-%{version}.jar
%{javadir}/xsltc.jar

%files manual
%defattr(-,root,root,-)
%doc build/docs/*

%files javadoc
%defattr(-,root,root,-)
%{javadocdir}/%{name}-%{version}

%files demo
%defattr(-,root,root,-)
%{_datadir}/%{name}

%changelog
* Wed Jan 22 2003 Ville Skytt <ville.skytta at iki.fi> - 2.4.1-2jpp
- bsf -> oldbsf.
- Use non-versioned jar in alternative, don't remove it on upgrade.
- Remove hardcoded packager tag.

* Mon Nov 04 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.4.1-1jpp
- 2.4.1

* Tue Sep 10 2002 Ville Skytt <ville.skytta at iki.fi> 2.4.0-1jpp
- 2.4.0.

* Thu Aug 22 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.4-0.D1.3jpp
- corrected case for Group tag
- fixed servlet classpath

* Tue Aug 20 2002 Ville Skytt <ville.skytta at iki.fi> 2.4-0.D1.2jpp
- Remove xerces-j1 runtime dependency.
- Add bcel, jlex, regexp to xsltc runtime requirements:
  <http://xml.apache.org/xalan-j/xsltc_usage.html>
- Build with -Dbuild.compiler=modern (IBM 1.3.1) to avoid stylebook errors.
- XSLTC now provides jaxp_transform_impl too.
- Earlier changes by Henri, from unreleased 2.4-D1.1jpp:
    Mon Jul 15 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.4-D1.1jpp
  - 2.4D1
  - use the jlex 1.2.5-5jpp (patched by Xalan/XSLTC team) rpm
  - use the stylebook-1.0-b3_xalan-2.jar included in source file till it will
    be packaged in jpackage
  - use jaxp_parser_impl (possibly xerces-j2) instead of xerces-j1 for docs
    generation, since it's tuned for stylebook-1.0-b3_xalan-2.jar
  - build and provide xsltc in a separate rpm

%changelog
* Mon Jul 01 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.3.1-2jpp 
- provides jaxp_transform_impl
- requires jaxp_parser_impl
- stylebook already requires xml-commons-apis
- jaxp_parser_impl already requires xml-commons-apis
- use sed instead of bash 2.x extension in link area to make spec compatible with distro using bash 1.1x

* Wed Jun 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 2.3.1-2jpp
- fix built classpath (bsf, bcel are existing jpackage rpms),
- add buildrequires for javacup and JLex

* Wed May 08 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.3.1-1jpp 
- 2.3.1
- vendor, distribution, group tags

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.3.0-2jpp 
- generic servlet support

* Wed Feb 20 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.3.0-1jpp 
- 2.3.0
- no more compat jar

* Sun Jan 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.0-2jpp 
- adaptation to new stylebook1.0b3 package
- used source tarball
- section macro

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.0-1jpp
- 2.2.0 final
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependency for compat and demo packages
- fixed package confusion
- adaptation for new servlet3 package
- requires xerces-j1 instead of jaxp_parser
- xml-apis jar now in required xml-commons-apis external package

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D14-1jpp
- 2.2.D14
- javadoc into javadoc package
- compat.jar into compat package
- compat javadoc into compat-javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 2.2.D13-2jpp
- changed extension to jpp
- prefixed xml-apis

* Tue Nov 20 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 2.2.D13-1jpp
- 2.2.D13
- removed packager tag

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D11-1jpp
- 2.2.D11

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D10-2jpp
- first unified release
- s/jPackage/JPackage

* Fri Sep 14 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D10-1mdk
- cvs references
- splitted demo package
- moved demo files to %{_datadir}/%{name}
- only manual package requires stylebook-1.0b3
- only demo package requires servletapi3

* Wed Aug 22 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D9-1mdk
- 2.2.9
- used new source packaging policy
- added samples data

* Wed Aug 08 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.2.D6-1mdk
- first Mandrake release
